.module Main

.include "sys/input.h.s"
.include "man/jet.h.s"
.include "man/race.h.s"
.include "sys/render.h.s"
.include "man/ai.h.s"
.include "sys/physics.h.s"
.include "sys/collision.h.s"
.include "sys/map.h.s"
.include "sys/music.h.s"
.include "cpctelera.h.s"
.include "man/inicio.h.s"


.area _DATA 
.area _CODE

.globl cpct_disableFirmware_asm
.globl cpct_waitVSYNC_asm
.globl cpct_setPALColour_asm

.globl espaciopulsado
.globl num_i
.globl num_mapa

_main::
   call cpct_disableFirmware_asm
  
   call sys_render_init
   call sys_input_init

   ld a, (espaciopulsado)
   cp #0
   jr z, Espacio_Pulsado   
Espacio_Pulsado:
   ld ix, #jet_storage
   call man_jet_init
   call man_race_init
   
   ld ix, #jet_storage
   call man_jet_create
   call sys_render_first_time
   call man_race_set_timer;manager interrupciones

   ld ix,#ai_storage
   call man_ai_init
   call man_ai_create
   call sys_render_ai_first_time

   call sys_music_init
   call man_inicio_init
   ld ix,#race_storage
   ld race_wins(ix),#0x30
   call sys_render_wins
   call sys_render_laps
 

loop:

   ld a,(sys_physics_cont_frames)
   inc a
   ld (sys_physics_cont_frames), a
   cp #0x30
   jr nz, fin_loop

    xor a
    ld (sys_physics_cont_frames),a

   
   ;call man_race_set_timer
   ld ix,#jet_storage
   
   call sys_render_update
   call sys_physics_comp_pos
   ;call sys_render_update
   call sys_input_update
   ; ld ix,#race_storage
   call sys_collision_update
   call sys_physics_update
   ;call man_race_set_timer

   ld ix,#ai_storage
   call sys_render_ai_entity
   ; call man_ai_move
   call sys_physics_comp_pos
   call man_ai_turn
   call sys_collision_ai_update
   call sys_physics_update_ai
   call man_race_update


   fin_loop:
   ; .rept 5 ;; esperas 5 veces a vsync y retrasas la ejecucion 5 fotogramas
   ;    halt
   ;    halt
      call cpct_waitVSYNC_asm
   ; .endm
   ;ld a,(num_i)
   jr loop
