.include "jet.h.s"
.include "cpctelera.h.s"
.include "globals.s"

jet_storage_size = max_jet * sizeof_e + 1

jet_next_free::  .dw jet_storage        ;; puntero a la primera entidad que hay libre
jet_storage::   .ds jet_storage_size   ;; reservo memoria del tamaño de las entidades
invalid_end_signal:: .db e_type_invalid          ;; byte para indicar el final

man_jet_init::
    ;; 1st free jet at the start of jet storage
    ld hl, #jet_storage
    ld (jet_next_free), hl
    ;; Init the complete jet array with "e_type_invalid"
    ld (hl), #e_type_invalid
    ld d,h
    ld e,l
    inc de
    ld bc, #jet_storage_size - 1
    ldir ;; coge lo que hay en hl y lo copia en de tantos bytes como diga bc

    ret

;; reservo espacio en el array de entidades para la nueva entidad
;; devuelvo: - en BC: el tamaño de la nueva entidad
;;           - en DE: el puntero a la nueva entidad
;; -------------------------------------------------------------------COMPLETAR
man_jet_create::
    ld e_type(ix), #e_type_default
    ld e_pos(ix), #j_pos_3
    ; ld e_prev_pos(ix), #j_pos_3
    ld e_x(ix), #40
    ld e_y(ix), #15
    ld e_vx(ix), #0
    ld e_vy(ix), #0
    ld e_w(ix), #4
    ld e_h(ix), #8
    ld e_prev_x(ix), #0x00
    ld e_prev_y(ix), #0xC0
    ld e_prev_pos(ix), #3
    ret

;; se le envia en hl principio de jet que se destruye
;; pone a 00 los valores del espacio de jet[x]

man_jet_create_map01::
    ld ix, #jet_storage
   ld e_pos(ix), #j_pos_3
    ; ld e_prev_pos(ix), #j_pos_3
    ld e_x(ix), #40
    ld e_y(ix), #15
    ld e_vx(ix), #0
    ld e_vy(ix), #0
    ld e_w(ix), #4
    ld e_h(ix), #8
    ld e_prev_x(ix), #0x00
    ld e_prev_y(ix), #0xC0
    ld e_prev_pos(ix), #3
    ret

man_jet_create_map02::
    ld ix, #jet_storage
    ld e_pos(ix), #j_pos_9
    ld e_x(ix), #50
    ld e_y(ix), #135
    ld e_vx(ix), #0
    ld e_vy(ix), #0
    ld e_prev_pos(ix), #9
    ret

man_jet_create_map03::
    ld ix, #jet_storage
    ld e_pos(ix), #j_pos_3
    ld e_x(ix), #30
    ld e_y(ix), #15
    ld e_vx(ix), #0
    ld e_vy(ix), #0
    ld e_prev_pos(ix), #3
    ret