.include "man/jet.h.s"
.include "man/inicio.h.s"

.include "man/race.h.s"
.include "cpctelera.h.s"
.include "../sys/render.h.s"
.include "../sys/map.h.s"
.include "sys/music.h.s"

race_next_free::  .dw race_storage        ;; puntero a la primera entidad que hay libre
race_storage:: .ds sizeof_r
r_invalid_end_signal:: .db r_type_invalid          ;; byte para indicar el final

man_race_init::
    ;; 1st free race at the start of race storage
    
    ld hl, #race_storage
    ld (race_next_free), hl
    ;; Init the complete race array with "e_type_invalid"
    ld (hl), #r_type_invalid
    inc hl
    inc hl
    inc hl
    inc hl
    inc hl
    inc hl
    ld (hl),#0xFF
    ld d,h
    ld e,l
    inc de
    ld bc, #sizeof_r - 1
    ldir
    push ix
    ld ix, #race_storage
    ld race_time_s_1(ix),#0x30
    ld race_time_s_2(ix),#0x30
    ld race_time_m(ix),#0x30
    ld race_n_vuelta(ix),#0x30
    ld race_n_vuelta_ai(ix),#0x30
    ld race_n_vuelta_aux(ix),#0x00
    ld race_n_vuelta_aux_ai(ix),#0x00
    ld race_orientation_1st(ix),#0x03
    pop ix 
    ret

man_race_comp_vuelta::
    push ix
    ld ix,#race_storage
    ld a,  race_orientation_1st(ix)
    pop ix
    ;
    cp #3
    jr z,first_position_3
        cp #6
        jr z,first_position_6
            cp #9
            jr z,first_position_9
                cp #12
                jr z,first_position_12
                    ret
    first_position_3:
        ; ld ix,#jet_storage
        ld a,e_pos(ix)
        cp #6
        jr nc,race_not_valid
            call man_race_au_vuelta
            ret
    first_position_6:
        ; ld ix,#jet_storage
        ld a,e_pos(ix)
        cp #8
        jr nc,race_not_valid
            cp #4
            jr c,race_not_valid
            call man_race_au_vuelta
            ret

    first_position_9:
        ; ld ix,#jet_storage
        ld a,e_pos(ix)
        cp #7
        jr c,race_not_valid
            call man_race_au_vuelta
            ret

    first_position_12:
        ; ld ix,#jet_storage
        ld a,e_pos(ix)
        cp #9
        jr c,first_12_true
            cp #3
            jr nc,first_12_true
                race_not_valid:
                    ld iy,#race_storage
                    ld a,#0xFF
                    ld race_n_vuelta_aux(iy),a
                    ret
            first_12_true:
            call man_race_au_vuelta
            ret
    ret

man_race_au_vuelta::
    ld iy,#race_storage
    ld a,race_n_vuelta_aux(iy)
    cp #0xFF
    jr z,validate_race
        cp #0x01
        ret z
            inc race_n_vuelta(iy)
             push ix
             call sys_render_laps
             pop ix
            ; inc a
     validate_race:
         ld race_n_vuelta_aux(iy),#0x01
    ret




;main_ir
;main_ir
num_i:: .db 255 ;300 interrupciones = 1s
man_race_timer::
    push hl    
    push af
    push de
    push bc

    ld a, (num_i)
     
    dec a
    jr nz, no_zero1
    ld a,#255
    push af
    push ix
    call man_race_suma_timer
    pop ix
    pop af
    no_zero1:
        ld (num_i),a
    pop bc
    pop de
    pop af
    pop hl
     
    ei
    ;ei ;habilitamos interrupciones
    reti


man_race_set_timer::
    
    im 1 ; modo interrupciones 1
    di
    ld a,#0xC3 ; jr
    ld (0x38),a
    ld hl,#man_race_timer
    ld (0x39), hl
    ei
    
    ret

man_race_suma_timer::
   ld ix,#race_storage
   ld a,race_time_s_2(ix);yy:yx
   inc a
   cp #0x3A ; da mas del permitido 10 en hex
   jr nz, no_se_pasa_s_1
        ld a,race_time_s_1(ix);yy;xy
        inc a
        cp #0x36
        jr nz, no_se_pasa_s_2
            ld a,race_time_m(ix)
            inc a
            ld race_time_m(ix),a
        ld a,#0x30
        no_se_pasa_s_2:
            
            ld race_time_s_1(ix),a
    ld a,#0x30
    no_se_pasa_s_1:
        ld race_time_s_2(ix),a
    ;render pa tos
    
    ;call sys_render_timer
    
ret


;; AI METHODS ==================
man_race_comp_ai_vuelta::
    push ix
    ld ix,#race_storage
    ld a,  race_orientation_1st(ix)
    pop ix
    cp #3
    jr z,ai_first_position_3
        cp #6
        jr z,ai_first_position_6
            cp #9
            jr z,ai_first_position_9
                cp #12
                jr z,ai_first_position_12
                    ret
    ai_first_position_3:
        ; ld ix,#jet_storage
        ld a,e_pos(ix)
        cp #6
        jr nc,ai_race_not_valid
            call man_race_au_ai_vuelta
            ret
    ai_first_position_6:
        ; ld ix,#jet_storage
        ld a,e_pos(ix)
        cp #8
        jr nc,ai_race_not_valid
            cp #4
            jr c,ai_race_not_valid
            call man_race_au_ai_vuelta
            ret

    ai_first_position_9:
        ; ld ix,#jet_storage
        ld a,e_pos(ix)
        cp #7
        jr c,ai_race_not_valid
            call man_race_au_ai_vuelta
            ret

    ai_first_position_12:
        ; ld ix,#jet_storage
        ld a,e_pos(ix)
        cp #9
        jr c,ai_first_12_true
            cp #3
            jr nc,ai_first_12_true
                ai_race_not_valid:
                    ld iy,#race_storage
                    ld a,#0xFF
                    ld race_n_vuelta_aux_ai(iy),a
                    ret
            ai_first_12_true:
            call man_race_au_ai_vuelta
            ret
    ret

man_race_au_ai_vuelta::
    ld iy,#race_storage
    ld a,race_n_vuelta_aux_ai(iy)
    cp #0xFF
    jr z,validate_ai_race
        cp #0x01
        ret z
            inc race_n_vuelta_ai(iy)
            ; inc a
    validate_ai_race:
        ld race_n_vuelta_aux_ai(iy),#0x01
    ret



man_race_update::;comprueba quien gana
push ix
    ld ix,#race_storage
    ld a, race_n_vuelta(ix)
    cp #0x35
    call z, man_race_win_jett
    ld a, race_n_vuelta_ai(ix)
    cp #0x35
    call z, man_race_lose_jett
    pop ix
        


ret

man_race_win_jett::
    ld a,race_n_vuelta_ai(ix)
    cp #0x35
    call nz, man_race_win
ret

man_race_lose_jett::
;se muestra la pantalla de lose y se reinicia
    call sys_render_lose
    ld ix, #race_storage
    
    ld race_time_s_2(ix),#0x30
    loop_lose:
        ld a, race_time_s_2(ix)
        cp #0x35
    jr nz,  loop_lose
    call man_inicio_init_vueltas
ret

man_race_win::
;se muestra la pantalla de win y pasa al siguiente mapa
    call sys_render_win
    ld ix, #race_storage
    ld race_time_s_2(ix),#0x30
    ;
    loop_win:
        ld a, race_time_s_2(ix)
        cp #0x35
    jr nz, loop_win
    ;pasa al siguiente mapa
    inc race_wins(ix)
    
    call sys_map_change
    ;call sys_render_wins
ret