.module Collision_System
.include "../man/jet.h.s"
.include "../man/ai.h.s"
.include "render.h.s"
.include "physics.h.s"
.include "map.h.s"

.include "../man/race.h.s"
 .area _CODE
 .include "cpctelera.h.s"


col_0:: .db 00
col_1:: .db 00
col_20:: .db 00
col_21:: .db 00


sys_collision_update::
    xor a
   ; call man_entity_get_from_idx
    call sys_collision_calculate_adress ; calcula solo la 0(iy), falta la 1(iy),20(iy),21(iy),40(iy),41(iy)
    call sys_collision_comprobar_tiles
ret
sys_collision_update2::
    xor a
   ; call man_entity_get_from_idx
    call sys_collision_calculate_adress ; calcula solo la 0(iy), falta la 1(iy),20(iy),21(iy),40(iy),41(iy)
    call sys_collision_comprobar_tiles
ret

sys_collision_calculate_adress::
    ld a,e_x(ix)
    srl a
    srl a
    ld c,a
    ld b,#0
    ld a,e_y(ix)
    and #0b11111000
    ld e,a
    srl e
    ld d,b
    ld l,a
    ld h,d
    add hl,hl
    add hl,de
    add hl,bc
    ex de,hl
    ld iy, #tilemap_ptr
    add iy,de
ret



sys_collision_comprobar_tiles:: ;coloca en los registros COL: 1 si es COLISION y 0 si NO ES COLISION
    xor a
    ;si colisiona abajo se mueve en x es decir, se cambia solo la y hacia abajo v
    cp (iy)
    jr nz, comprobar_en_0
        xor a
        ld (col_0),a

        push iy
        ld iy,#race_storage
        ld a,race_n_vuelta_aux(iy)
        cp #0xFF
        jr z, skip_0
        ld race_n_vuelta_aux(iy), #0x00
        skip_0:
        pop iy
        comprobar_0_fin:
        
    xor a  
    cp 1(iy)
    jr nz, comprobar_en_1
        xor a
        ld (col_1),a
    comprobar_1_fin:
    xor a  
    cp 20(iy)
    jr nz, comprobar_en_20
        xor a
        ld (col_20),a
        comprobar_20_fin:

    xor a  
    cp 21(iy)
    jr nz, comprobar_en_21
        xor a
        ld (col_21),a
        jr fin_collision_comprobar_tiles

    comprobar_en_0: ;;MODIFICAR META
        ld a, (iy)
        cp #0x0A;meta1
        jr z, el_tile_es_meta_en_0
        


        ld a,#1
        ld (col_0),a
        jr comprobar_0_fin

        el_tile_es_meta_en_0:
        xor a
        ld (col_0),a

        push iy
        call man_race_comp_vuelta
        ld a,race_n_vuelta_aux(iy)
        cp #0xFF
        jr z,no_mod_01
        ld race_n_vuelta_aux(iy),#0x01
        no_mod_01:
        pop iy
        jr comprobar_0_fin
    comprobar_en_1:
        ld a, 1(iy)
        cp #0x0A;meta1
        jr z, comprobar_1_fin
        
        ld a,#1
        ld (col_1),a
        jr comprobar_1_fin
    comprobar_en_20:
        ld a, 20(iy)
        cp #0x0A;meta1
        jr z, el_tile_es_meta_en_20
        


        ld a,#1
        ld (col_20),a
        jr comprobar_20_fin

        el_tile_es_meta_en_20:
        xor a
        ld (col_20),a

        push iy
        call man_race_comp_vuelta
        ld a,race_n_vuelta_aux(iy)
        cp #0xFF
        jr z,no_mod_01_2
        ld race_n_vuelta_aux(iy),#0x01
        no_mod_01_2:
        pop iy
        jr comprobar_20_fin
    comprobar_en_21:
        ld a, 21(iy)
        cp #0x0A;meta1
        jr z, fin_collision_comprobar_tiles

        ld a,#1
        ld (col_21),a
        jr fin_collision_comprobar_tiles
    fin_collision_comprobar_tiles:
    ld iy,#race_storage
    ld a,race_n_vuelta_aux(iy)
    cp #0xFF
    ret z
    cp #0x01
    ret z
        ld race_n_vuelta_aux(iy),#0x00
ret

sys_collision_es_meta::
ret


;; METODOS IA =========================

sys_collision_ai_comprobar_tiles:: ;coloca en los registros COL: 1 si es COLISION y 0 si NO ES COLISION
    xor a
    ;si colisiona abajo se mueve en x es decir, se cambia solo la y hacia abajo v
    cp (iy)
    jr nz, ai_comprobar_en_0
        xor a
        ld (ai_col_0),a
        push iy
        ld iy,#race_storage
        ld a,race_n_vuelta_aux_ai(iy)
        cp #0xFF
        jr z, skip_ai_0
        ld race_n_vuelta_aux_ai(iy), #0x00
        skip_ai_0:
        pop iy
        ai_comprobar_0_fin:
        
    xor a  
    cp 1(iy)
    jr nz, ai_comprobar_en_1
        xor a
        ld (ai_col_1),a
    ai_comprobar_1_fin:
    xor a  
    cp 20(iy)
    jr nz, ai_comprobar_en_20
        xor a
        ld (ai_col_20),a
        ai_comprobar_20_fin:

    xor a  
    cp 21(iy)
    jr nz, ai_comprobar_en_21
        xor a
        ld (ai_col_21),a
    

    jr ai_fin_collision_comprobar_tiles
        ai_comprobar_en_0: ;;MODIFICAR META
        ld a, (iy)
        cp #0x0A;meta1
        jr z, ai_el_tile_es_meta_en_0
        


        ld a,#1
        ld (ai_col_0),a

        jr ai_comprobar_0_fin

        ai_el_tile_es_meta_en_0:
        xor a
        ld (col_0),a

        push iy
        call man_race_comp_ai_vuelta
        ld a,race_n_vuelta_aux_ai(iy)
        cp #0xFF
        jr z,ai_no_mod_01
        ld race_n_vuelta_aux_ai(iy),#0x01
        ai_no_mod_01:
        pop iy
        
        jr ai_comprobar_0_fin
    ai_comprobar_en_1:
        ld a, 1(iy)
        cp #0x0A;meta1
        jr z, ai_comprobar_1_fin
        


        ld a,#1
        ld (ai_col_1),a
        jr ai_comprobar_1_fin
    ai_comprobar_en_20:
        ld a, 20(iy)
        cp #0x0A;meta1
        jr z, ai_el_tile_es_meta_en_20
        


        ld a,#1
        ld (ai_col_20),a
        jr ai_comprobar_20_fin

        ai_el_tile_es_meta_en_20:
        xor a
        ld (ai_col_20),a

        push iy
        call man_race_comp_ai_vuelta
        ld a,race_n_vuelta_aux_ai(iy)
        cp #0xFF
        jr z,ai_no_mod_01_2
        ld race_n_vuelta_aux_ai(iy),#0x01
        ai_no_mod_01_2:
        pop iy
        jr ai_comprobar_20_fin
    ai_comprobar_en_21:
        ld a, 21(iy)
        cp #0x0A;meta1
        jr z, ai_fin_collision_comprobar_tiles
        


        ld a,#1
        ld (ai_col_21),a
        jr ai_fin_collision_comprobar_tiles


    ai_fin_collision_comprobar_tiles:
    ld iy,#race_storage
    ld a,race_n_vuelta_aux_ai(iy)
    cp #0xFF
    ret z
    cp #01
    ret z

        ld race_n_vuelta_aux_ai(iy),#0x00
ret

sys_collision_ai_update::
    xor a
    call sys_collision_calculate_adress ; calcula solo la 0(iy), falta la 1(iy),20(iy),21(iy),40(iy),41(iy)
    call sys_collision_ai_comprobar_tiles
ret
