.include "input.h.s"
.include "man/jet.h.s"
.include "man/inicio.h.s"
.include "sys/physics.h.s"
.include "sys/render.h.s"
.include "sys/map.h.s"
.include "music.h.s"
.include "cpctelera.h.s"
.globl num_mapa
.globl cpct_scanKeyboard_asm
.globl cpct_isKeyPressed_asm

espaciopulsado:: .db 0
menu_mostrado:: .db 0

sys_input_init::
loop:
    call cpct_scanKeyboard_asm

    ld hl, #Key_Space
    call cpct_isKeyPressed_asm
    jr  z,  Space_NotPressed
Space_Pressed:
    ld a, (espaciopulsado)
    ld a, #1
    ld (espaciopulsado),a

    call sys_render_clear
    call sys_render_map01

    jr Space_End

Space_NotPressed:
    call sys_render_menu
    jr loop
    
Space_End:
    ret

sys_input_update::
    call cpct_scanKeyboard_asm

    ld hl, #Key_N
    call cpct_isKeyPressed_asm
    jr  z,  N_NotPressed
N_Pressed:
    call sys_map_change
N_NotPressed:
    ld hl, #Key_Q
    call cpct_isKeyPressed_asm
    jr  z,  Q_NotPressed

    Q_Pressed:
        call sys_physics_accel
        jr turn

    Q_NotPressed:
        call sys_physics_stop
            ld a,e_vx(ix)
            or e_vy(ix)
            jr nz, turn
    turn:
            ld hl, #Key_O
        call cpct_isKeyPressed_asm
        jr nz, turn_left
            ld hl, #Key_P
            call cpct_isKeyPressed_asm
            jr nz, turn_right
                ret
            turn_right:
                call sys_physics_turn_right
                ret
        turn_left:
            call sys_physics_turn_left

    ret