.include "physics.h.s"
.include "man/jet.h.s"
.include "man/ai.h.s"
.include "cpctelera.h.s"
.include "collision.h.s"
.include "globals.s"

sys_physics_cont_frames :: .db 00

sys_physics_update_one_entity::

    call sys_physics_collision_move

    ld  a, e_x(ix)
    add e_vx(ix)
    ld e_x(ix), a

    ld  a, e_y(ix)
    add e_vy(ix)
    ld e_y(ix), a

    ret

sys_physics_update::
    ; ld hl, #sys_physics_update_one_entity
    ; call man_entity_forall
    call sys_physics_update_one_entity
    ret

sys_physics_turn_right::

    ld a, e_cont_turn(ix)
    cp #2
    jr nc,turn_r
        inc e_cont_turn(ix)
        ret
    turn_r:

        ld a,e_pos(ix)
            cp #0x0C
            jr z,vuelta_reloj_r
                inc e_pos(ix)
                jr end_turn_r
            vuelta_reloj_r:
                ld e_pos(ix), #0x01
        end_turn_r:
            ld e_cont_turn(ix),#0

    ;
    ret

sys_physics_turn_left::

    ld a, e_cont_turn(ix)
    cp #2
    jr nc,turn_l
        inc e_cont_turn(ix)
        ret
    ; call sys_physics_comp_vmax
    turn_l:

        ld a,e_pos(ix)
            cp #0x01
            jr z,vuelta_reloj_l
                dec e_pos(ix)
                jr end_turn_l
            vuelta_reloj_l:
                ld e_pos(ix), #0x0C
        end_turn_l:
            ld e_cont_turn(ix),#0
    ret
sys_physics_comp_pos::

        ; ld e_vmax_x(ix),#3
        ; ld e_vmax_y(ix),#3
        ; ld e_vmin_x(ix),#-3
        ; ld e_vmin_y(ix),#-3
    ld a,e_pos(ix)
    ld e_prev_pos(ix), a


    ld a,e_pos(ix)
    cp #0x01
    jr z,pos1
    cp #0x02
    jr z,pos2
    cp #0x03
    jr z,pos3
    cp #0x04
    jr z,pos4
    cp #0x05
    jr z,pos5
    cp #0x06
    jr z,pos6
    cp #0x07
    jr z,pos7
    cp #0x08
    jr z,pos8
    cp #0x09
    jr z,pos9
    cp #0x0A
    jr z,pos10
    cp #0x0B
    jr z,pos11
    cp #0x0C
    jr z,pos12

    pos6:
    pos12: ; HACIA ARRIBA / HACIA ABAJO
        ld e_vmax_x(ix),#0
        ld e_vmax_y(ix),#6
        ld e_vmin_x(ix),#0
        ld e_vmin_y(ix),#-6
        jr end_comp
    pos1:
    pos7:
    pos5:
    pos11:
     ; HACIA 2&7 / HACIA 5&11
        ld e_vmax_x(ix),#1
        ld e_vmax_y(ix),#4
        ld e_vmin_x(ix),#-1
        ld e_vmin_y(ix),#-4
        jr end_comp
    pos2:
    pos8:
    pos4:
    pos10:
     ;HACIA 2&8 / HACIA 4&10
        ld e_vmax_x(ix),#2
        ld e_vmax_y(ix),#2
        ld e_vmin_x(ix),#-2
        ld e_vmin_y(ix),#-2
        jr end_comp
    pos3:
    pos9: ;HACIA DER / HACIA IZQ
        ld e_vmax_x(ix),#3
        ld e_vmax_y(ix),#0
        ld e_vmin_x(ix),#-3
        ld e_vmin_y(ix),#0
        jr end_comp

    end_comp:

    ret
sys_physics_accel:: ;;WIP

    ld a, e_cont_accel(ix)
    cp #6 ;ACCEL_MAX
    jr z,accel
    cp #2
    jr z,accel
    cp #0
    jr z,accel
        inc e_cont_accel(ix)
        ret

    accel:
    ld a,e_pos(ix)
    cp #6
    jr nc, vel_neg_x
    ;vel_pos_x
        ld a,e_vx(ix)
        cp e_vmax_x(ix)
        jr z,end_vel_x
        jr nc,set_vmax_x
        ;no_vel_max_x
            ld a, e_vmax_x(ix)
            cp #0
            jr z,vx_set_0
            inc e_vx(ix)
            jr end_vel_x
        ;
        set_vmax_x:
            ld a,e_vmax_x(ix)
            ld e_vx(ix),a
            jr end_vel_x
    ;
    vel_neg_x:
        ld a,e_vx(ix)
        cp e_vmin_x(ix)
        jr z,end_vel_x
        jr c,set_vmin_x
        ;no_vel_min_x
            ld a, e_vmin_x(ix)
            cp #0
            jr z, vx_set_0
            dec e_vx(ix)
            jr end_vel_x
            vx_set_0:
                ld e_vx(ix), a
                jr end_vel_x
        ;
        set_vmin_x:
            ld a,e_vx(ix)
            cp #0
            jr z,dec_set_vx
                ld a,e_vmin_x(ix)
                ld e_vx(ix),a
                jr end_vel_x
            dec_set_vx:
                dec e_vx(ix)

    end_vel_x:

    ld a,e_pos(ix)
    cp #3
    jr z, set_vy_0
    jr c, vel_neg_y
        ld a,e_pos(ix)
        cp #9
        jr z, set_vy_0
        jr nc, vel_neg_y

    ;vel_pos_x
        ld a,e_vy(ix)
        cp e_vmax_y(ix)
        jr z,end_vel_y
        jr nc,set_vmax_y
        ;no_vel_max_x
            ld a,e_vmax_y(ix)
            cp #0
            jr z,set_vy_0
            inc e_vy(ix)
            jr end_vel_y
        ;
        set_vmax_y:
            ld a,e_vmax_y(ix)
            ld e_vy(ix), a
            jr end_vel_y
    ;
    vel_neg_y:
        ld a,e_vy(ix)
        cp e_vmin_y(ix)
        jr z,end_vel_y
        jr c, set_vmin_y
        ;no_vel_min_x
            ld a,e_vmin_y(ix)
            cp #0
            jr z,set_vy_0
            dec e_vy(ix)
            jr end_vel_y
        set_vmin_y:
        ld a,e_vy(ix)
        cp #0
        jr z, dec_set_vy
            ld a,e_vmin_y(ix)
            ld e_vy(ix), a
            jr end_vel_y
        dec_set_vy:
        dec e_vy(ix)
        jr end_vel_y

        set_vy_0:
        ld e_vy(ix), #0
        ;
    end_vel_y:

        ld a,e_cont_accel(ix)
        cp #6 ;ACCEL_MAX
        ret z
            inc e_cont_accel(ix)

    ret

sys_physics_stop::

    ld a, e_cont_accel(ix)
    cp #0
    jr z, stop_j
    ld a, e_cont_accel(ix)
    cp #2
    jr z,stop_j
    ld a, e_cont_accel(ix)
    cp #4
    jr z,stop_j
        dec e_cont_accel(ix)
        ret

    stop_j:
    ld a,e_vx(ix) ;FE o 02
    cp #0
    jr z, stop_y
        ;stop_x
        ld a,e_vx(ix)
        cp #0xF0
        jr c, dec_vel_x
            inc e_vx(ix)
            jr stop_y
        dec_vel_x:
            dec e_vx(ix)
            jr stop_y

    stop_y:
    ld a,e_vy(ix)
    cp #0
    ret z
        ld a,e_vy(ix)
        cp #0xF0
        jr c, dec_vel_y
            inc e_vy(ix)
            ret
        dec_vel_y:
            dec e_vy(ix)
    ret

sys_physics_collision_move:: ;; 2 = colision meta , 1 = colision pared *NO DETECTA PARED PERO SI META*
    ld a, (col_0)
    cp #1
    jr nz, no_col_0
        ld a,(col_1)
        cp #1
        jr nz,no_col_0_1
            ld a,e_vmax_y(ix)
            ld e_vy(ix),a
            ld a,(col_20) ;ESQUINAS
            cp #1
            jr nz, comp_col_0_1_21
            ld a,e_vmax_x(ix)
            ld e_vx(ix),a
            comp_col_0_1_21:
            ld a,(col_21) ;ESQUINAS
            cp #1
            ret nz
            ld a,e_vmin_x(ix)
            ld e_vx(ix),a
            ret
        no_col_0_1:
        ld a,(col_20)
        cp #1
        jr nz,no_col_0_20
            ld a,e_vmax_x(ix)
    
            ld e_vx(ix),a
            ld a,(col_21) ;ESQUINAS
            cp #1
            ret nz
            ld a,e_vmin_y(ix)
            ld e_vy(ix),a
            ret
        no_col_0_20:
        ld a,e_vmax_x(ix)
            ld e_vx(ix),a
        ld a,e_vmax_y(ix)
            ld e_vy(ix),a
            ld a,(col_21) ;ESQUINAS
            cp #1
            ret nz
            ld a,e_vmin_y(ix)
            ld e_vy(ix),a
            ret

    no_col_0:
    ld a, (col_20)
    cp #1
    jr nz,no_col_20
        ld a, (col_21)
        cp #1
        jr nz, no_col_20_21
            ld a,e_vmin_y(ix)
            ld e_vy(ix),a
            ld a,(col_1) ;ESQUINAS
            cp #1
            ret nz
            ld a,e_vmin_x(ix)
            ld e_vx(ix),a
            ret
        no_col_20_21:
            ld a,e_vmax_x(ix)
            ld e_vx(ix),a
            ld a,e_vmin_y(ix)
            ld e_vy(ix),a
            ld a,(col_1) ;ESQUINAS
            cp #1
            ret nz
            ld a,e_vmax_y(ix)
            ld e_vy(ix),a
            ret
    no_col_20:
    ld a, (col_1)
    cp #1
    jr nz,no_col_1
        ld a,(col_21)
        cp #1
        jr nz,no_col_1_21
            ld a,e_vmin_x(ix)
            ld e_vx(ix),a
            ret
        no_col_1_21:
        ld a,e_vmin_x(ix)
            ld e_vx(ix),a
        ld a,e_vmax_y(ix)
            ld e_vy(ix),a

            ret
    no_col_1:

    ld a,(col_21)
    cp #1
    ret nz
        ld a,e_vmin_x(ix)
        ld e_vx(ix),a
        ld a,e_vmin_y(ix)
        ld e_vy(ix),a


    ret

;; METODOS IA =================================

sys_physics_update_ai::
    call sys_physics_update_ai_entity
    ret
sys_physics_update_ai_entity::

    ld a,(ai_col_0)
    ld hl,#ai_col_1
    sub (hl)
    ld hl,#ai_col_20
    sub (hl)
    ld hl,#ai_col_21
    sub (hl)
    sub ai_col_cont(ix)
    cp #0
    jr z, ai_accel
        ld a,ai_turn_mode(ix)
        cp #0
        jr z,ai_accel
        ;ai_stop
        ld a,ai_col_cont(ix)
        cp #0
        jr nz,cont_continue
            call cpct_getRandom_xsp40_u8_asm
            and #0b00000110
            or #0b00000001
            ld ai_col_time_cont(ix),a
        cont_continue:
        ld a,ai_col_cont(ix)
        cp ai_col_time_cont(ix)
        jr z,ai_stop_reset
            ld a,ai_turn_cont(ix)
            cp #0
            jr z,ai_stop_reset
            call sys_physics_stop
            inc ai_col_cont(ix)
            jr ai_end_accel_comp
        ai_stop_reset:
            ld ai_col_cont(ix),#0
    ai_accel:
        call sys_physics_accel
    ai_end_accel_comp:

    call sys_physics_ai_collision_move

    ld  a, e_x(ix)
    add e_vx(ix)
    ld e_x(ix), a

    ld  a, e_y(ix)
    add e_vy(ix)
    ld e_y(ix), a

    ld  a, ai_collision_x(ix)
    add e_vx(ix)
    ld ai_collision_x(ix), a

    ld  a, ai_collision_y_0(ix)
    add e_vy(ix)
    ld ai_collision_y_0(ix), a

    ld  a, ai_collision_y_60(ix)
    add e_vy(ix)
    ld ai_collision_y_60(ix), a

    ret

sys_physics_ai_turn_left::
    call sys_physics_turn_left
    ld a,ai_cont_section(ix)
    cp #8
    jr z,end_cont_l
        inc ai_cont_section(ix)
        ret
    end_cont_l:
        ld ai_turn_mode(ix),#0
        ld ai_cont_section(ix),#0
        ld e_cont_turn(ix),#0
        ld a,ai_section(ix)
        cp #1
        jr z, repos_cont_r
            dec ai_section(ix)
            ret
        repos_cont_r:
        ld ai_section(ix), #4
    ret

sys_physics_ai_turn_right::
    call sys_physics_turn_right
    ld a,ai_cont_section(ix)
    cp #8
    jr z,end_cont_r
        inc ai_cont_section(ix)
        ret
    end_cont_r:
        ld ai_turn_mode(ix),#0
        ld ai_cont_section(ix),#0
        ld e_cont_turn(ix),#0
        ld a,ai_section(ix)
        cp #4
        jr z, repos_cont_l
            inc ai_section(ix)
            ret
        repos_cont_l:
        ld ai_section(ix), #1
    ret


sys_physics_ai_collision_move:: ;; 2 = colision meta , 1 = colision pared *NO DETECTA PARED PERO SI META*
    ld a, (ai_col_0)
    cp #1
    jr nz, ai_no_col_0
        ld a,(ai_col_1)
        cp #1
        jr nz,ai_no_col_0_1
            ld a,e_vmax_y(ix)
            ld e_vy(ix),a
            ld a,(ai_col_20) ;ESQUINAS
            cp #1
            jr nz, ai_comp_col_0_1_21
            ld a,e_vmax_x(ix)
            ld e_vx(ix),a
            ai_comp_col_0_1_21:
            ld a,(ai_col_21) ;ESQUINAS
            cp #1
            ret nz
            ld a,e_vmin_x(ix)
            ld e_vx(ix),a
            ret
        ai_no_col_0_1:
        ld a,(ai_col_20)
        cp #1
        jr nz,ai_no_col_0_20
            ld a,e_vmax_x(ix)
    
            ld e_vx(ix),a
            ld a,(ai_col_21) ;ESQUINAS
            cp #1
            ret nz
            ld a,e_vmin_y(ix)
            ld e_vy(ix),a
            ret
        ai_no_col_0_20:
        ld a,e_vmax_x(ix)
            ld e_vx(ix),a
        ld a,e_vmax_y(ix)
            ld e_vy(ix),a
            ld a,(ai_col_21) ;ESQUINAS
            cp #1
            ret nz
            ld a,e_vmin_y(ix)
            ld e_vy(ix),a
            ret

    ai_no_col_0:
    ld a, (ai_col_20)
    cp #1
    jr nz,ai_no_col_20
        ld a, (ai_col_21)
        cp #1
        jr nz, ai_no_col_20_21
            ld a,e_vmin_y(ix)
            ld e_vy(ix),a
            ld a,(ai_col_1) ;ESQUINAS
            cp #1
            ret nz
            ld a,e_vmin_x(ix)
            ld e_vx(ix),a
            ret
        ai_no_col_20_21:
            ld a,e_vmax_x(ix)
            ld e_vx(ix),a
            ld a,e_vmin_y(ix)
            ld e_vy(ix),a
            ld a,(ai_col_1) ;ESQUINAS
            cp #1
            ret nz
            ld a,e_vmax_y(ix)
            ld e_vy(ix),a
            ret
    ai_no_col_20:
    ld a, (ai_col_1)
    cp #1
    jr nz,ai_no_col_1
        ld a,(ai_col_21)
        cp #1
        jr nz,ai_no_col_1_21
            ld a,e_vmin_x(ix)
            ld e_vx(ix),a
            ret
        ai_no_col_1_21:
        ld a,e_vmin_x(ix)
            ld e_vx(ix),a
        ld a,e_vmax_y(ix)
            ld e_vy(ix),a

            ret
    ai_no_col_1:

    ld a,(ai_col_21)
    cp #1
    ret nz
        ld a,e_vmin_x(ix)
        ld e_vx(ix),a
        ld a,e_vmin_y(ix)
        ld e_vy(ix),a


    ret

; sys_physics_ai_comp_pos::

;         ; ld e_vmax_x(ix),#3
;         ; ld e_vmax_y(ix),#3
;         ; ld e_vmin_x(ix),#-3
;         ; ld e_vmin_y(ix),#-3
;     ld a,e_pos(ix)
;     ld e_prev_pos(ix), a


;     ld a,e_pos(ix)
;     cp #0x01
;     jr z,pos1_ai
;     cp #0x02
;     jr z,pos2_ai
;     cp #0x03
;     jr z,pos3_ai
;     cp #0x04
;     jr z,pos4_ai
;     cp #0x05
;     jr z,pos5_ai
;     cp #0x06
;     jr z,pos6_ai
;     cp #0x07
;     jr z,pos7_ai
;     cp #0x08
;     jr z,pos8_ai
;     cp #0x09
;     jr z,pos9_ai
;     cp #0x0A
;     jr z,pos10_ai
;     cp #0x0B
;     jr z,pos11_ai
;     cp #0x0C
;     jr z,pos12_ai

;     pos6_ai:
;     pos12_ai: ; HACIA ARRIBA / HACIA ABAJO
;         ld e_vmax_x(ix),#0
;         ld e_vmax_y(ix),#6
;         ld e_vmin_x(ix),#0
;         ld e_vmin_y(ix),#-6
;         jr ai_end_comp
;     pos1_ai:
;     pos7_ai:
;     pos5_ai:
;     pos11_ai:
;      ; HACIA 2&7 / HACIA 5&11
;         ld e_vmax_x(ix),#1
;         ld e_vmax_y(ix),#4
;         ld e_vmin_x(ix),#-1
;         ld e_vmin_y(ix),#-4
;         jr ai_end_comp
;     pos2_ai:
;     pos8_ai:
;     pos4_ai:
;     pos10_ai:
;      ;HACIA 2&8 / HACIA 4&10
;         ld e_vmax_x(ix),#2
;         ld e_vmax_y(ix),#2
;         ld e_vmin_x(ix),#-2
;         ld e_vmin_y(ix),#-2
;         jr ai_end_comp
;     pos3_ai:
;     pos9_ai: ;HACIA DER / HACIA IZQ
;         ld e_vmax_x(ix),#3
;         ld e_vmax_y(ix),#0
;         ld e_vmin_x(ix),#-3
;         ld e_vmin_y(ix),#0
;         jr ai_end_comp

;     ai_end_comp:

;     ret