.include "render.h.s"
.include "man/jet.h.s"
.include "cpctelera.h.s"
.include "map.h.s"
.include "music.h.s"
.include "../man/race.h.s"
.include "imgs/naves.h.s"

.globl cpct_drawSpriteBlended_asm
.globl cpct_getScreenPtr_asm
.globl cpct_drawSolidBox_asm
.globl cpct_setVideoMode_asm
.globl cpct_setPalette_asm
.globl cpct_drawSprite_asm
.globl cpct_drawSolidBox_asm
.globl cpct_etm_drawTilemap4x8_ag_asm
.globl cpct_etm_setDrawTilemap4x8_ag_asm
.globl cpct_drawStringM0_asm
.globl cpct_setDrawCharM0_asm
.globl cpct_zx7b_decrunch_s_asm

.globl cpct_drawCharM0_asm
.globl sys_physics_comp_pos

num_mapa:: .db 0x00
.globl num_cont

sys_render_one_entity::
    ld a, e_prev_pos(ix)
    call sys_render_status_jet
    ld  d, e_prev_y(ix)
    ld  e, e_prev_x(ix)
    ld  a, #0  ;; color de fondo a pintar
    ld  b, e_w(ix)
    ld  c, e_h(ix)
    call cpct_drawSpriteBlended_asm
    ; call cpct_drawSolidBox_asm

    ld  de, #CPCT_VMEM_START_ASM
    ld  b,  e_y(ix)
    ld  c,  e_x(ix)
    call cpct_getScreenPtr_asm

    ; ;; la función de aquí ^ me devuelve en HL el puntero de la memoria de vídeo
    ld e_prev_x(ix), l
    ld e_prev_y(ix), h

    ex  de, hl
    ld a, e_pos(ix)
    call sys_render_status_jet
    ; ld  hl, #_sp_nave
    ld  b,  e_w(ix)
    ld  c,  e_h(ix)
    call cpct_drawSpriteBlended_asm

    ret

sys_render_first_time::
    ld  de, #CPCT_VMEM_START_ASM
       
    ld  b,  e_y(ix)
    ld  c,  e_x(ix)
    call cpct_getScreenPtr_asm

    ; ;; la función de aquí ^ me devuelve en HL el puntero de la memoria de vídeo
    ld e_prev_x(ix), l
    ld e_prev_y(ix), h

    ex  de, hl
    ld a, e_pos(ix)
    call sys_render_status_jet
    ; ld  hl, #_sp_nave
    ld  b,  e_w(ix)
    ld  c,  e_h(ix)
    call cpct_drawSpriteBlended_asm
    ret
    
sys_render_status_jet::
    cp #12
    jr z, paint_jet_12
    cp #11
    jr z, paint_jet_11
    cp #10
    jr z, paint_jet_10
    cp #9
    jr z, paint_jet_9
    cp #8
    jr z, paint_jet_8
    cp #7
    jr z, paint_jet_7
    cp #6
    jr z, paint_jet_6
    cp #5
    jr z, paint_jet_5
    cp #4
    jr z, paint_jet_4
    cp #3
    jr z, paint_jet_3
    cp #2
    jr z, paint_jet_2
        ld hl,#_sp_naves_00
        ret
    paint_jet_2:
        ld hl,#_sp_naves_01
        ret
    paint_jet_3:
        ld hl,#_sp_naves_02
        ret
    paint_jet_4:
        ld hl,#_sp_naves_03
        ret
    paint_jet_5:
        ld hl,#_sp_naves_04
        ret
    paint_jet_6:
        ld hl,#_sp_naves_05
        ret
    paint_jet_7:
        ld hl,#_sp_naves_06
        ret
    paint_jet_8:
        ld hl,#_sp_naves_07
        ret
    paint_jet_9:
        ld hl,#_sp_naves_08
        ret
    paint_jet_10:
        ld hl,#_sp_naves_09
        ret
    paint_jet_11:
        ld hl,#_sp_naves_10
        ret
    paint_jet_12:
        ld hl,#_sp_naves_11
    ret


sys_render_init::
    
    ;; Modo 0
    ld      c, #0
    call    cpct_setVideoMode_asm

    ld      hl, #_g_palette
    ld      de, #16
    call    cpct_setPalette_asm
    cpctm_setBorder_asm HW_BLACK
    ret

sys_render_show_map::
    ld bc, #0x1414
    ld de, #20
    ld hl, #tileset_ptr
    call cpct_etm_setDrawTilemap4x8_ag_asm

    ld  hl, #CPCT_VMEM_START_ASM
    ld  de, #tilemap_ptr
    call cpct_etm_drawTilemap4x8_ag_asm
    ret

sys_render_map01::
    call sys_render_hud
    call sys_map_decompress_map01
    call sys_render_show_map
    ret

sys_render_map02::
    call sys_render_hud
    call sys_map_decompress_map02
    call sys_render_show_map
    ret

sys_render_map03::
    call sys_render_hud
    call sys_map_decompress_map03
    call sys_render_show_map 
    ret

sys_render_hud::
    ld  de, #0xFFFF
    ld  hl, #_hud_comp_end
    call cpct_zx7b_decrunch_s_asm 

    ld l, #0x0C
    ld h, #0
    call cpct_setDrawCharM0_asm
    call sys_render_wins
    call sys_render_laps

    ret

sys_render_update::
    ;;ld      hl, #sys_render_one_entity
    ;;call    man_entity_forall
    push ix
    call sys_render_timer
    pop ix
    call sys_render_one_entity
    
    ret


sys_render_menu::
    ld  hl, #_menu_comp_end
    ld  de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm 
    ret

sys_render_clear::
    cpctm_clearScreen_asm 0
    ret


;; COMANDOS IA ==========================

sys_render_ai_entity::
ld a, e_prev_pos(ix)
    call sys_render_ai_status_jet
    ld  d, e_prev_y(ix)
    ld  e, e_prev_x(ix)
    ld  a, #0  ;; color de fondo a pintar
    ld  b, e_w(ix)
    ld  c, e_h(ix)
    call cpct_drawSpriteBlended_asm
    ; call cpct_drawSolidBox_asm

    ld  de, #CPCT_VMEM_START_ASM
    ld  b,  e_y(ix)
    ld  c,  e_x(ix)
    call cpct_getScreenPtr_asm

    ; ;; la función de aquí ^ me devuelve en HL el puntero de la memoria de vídeo
    ld e_prev_x(ix), l
    ld e_prev_y(ix), h

    ex  de, hl
    ld a, e_pos(ix)
    call sys_render_ai_status_jet
    ; ld  hl, #_sp_nave
    ld  b,  e_w(ix)
    ld  c,  e_h(ix)
    call cpct_drawSpriteBlended_asm
    ret

    sys_render_ai_status_jet::
    cp #12
    jr z, paint_jet_12_ia
    cp #11
    jr z, paint_jet_11_ia
    cp #10
    jr z, paint_jet_10_ia
    cp #9
    jr z, paint_jet_9_ia
    cp #8
    jr z, paint_jet_8_ia
    cp #7
    jr z, paint_jet_7_ia
    cp #6
    jr z, paint_jet_6_ia
    cp #5
    jr z, paint_jet_5_ia
    cp #4
    jr z, paint_jet_4_ia
    cp #3
    jr z, paint_jet_3_ia
    cp #2
    jr z, paint_jet_2_ia
        ld hl,#_sp_naves_12
        ret
    paint_jet_2_ia:
        ld hl,#_sp_naves_13
        ret
    paint_jet_3_ia:
        ld hl,#_sp_naves_14
        ret
    paint_jet_4_ia:
        ld hl,#_sp_naves_15
        ret
    paint_jet_5_ia:
        ld hl,#_sp_naves_16
        ret
    paint_jet_6_ia:
        ld hl,#_sp_naves_17
        ret
    paint_jet_7_ia:
        ld hl,#_sp_naves_18
        ret
    paint_jet_8_ia:
        ld hl,#_sp_naves_19
        ret
    paint_jet_9_ia:
        ld hl,#_sp_naves_20
        ret
    paint_jet_10_ia:
        ld hl,#_sp_naves_21
        ret
    paint_jet_11_ia:
        ld hl,#_sp_naves_22
        ret
    paint_jet_12_ia:
        ld hl,#_sp_naves_23
    ret


sys_render_ai_first_time::
    ld  de, #CPCT_VMEM_START_ASM
       
    ld  b,  e_y(ix)
    ld  c,  e_x(ix)
    call cpct_getScreenPtr_asm

    ; ;; la función de aquí ^ me devuelve en HL el puntero de la memoria de vídeo
    ld e_prev_x(ix), l
    ld e_prev_y(ix), h

    ex  de, hl
    ld a, e_pos(ix)
    call sys_render_ai_status_jet
    ; ld  hl, #_sp_nave
    ld  b,  e_w(ix)
    ld  c,  e_h(ix)
    call cpct_drawSpriteBlended_asm

    ret

sys_render_first_time2::
    ld  de, #CPCT_VMEM_START_ASM
       
    ld  b,  e_y(ix)
    ld  c,  e_x(ix)
    call cpct_getScreenPtr_asm

    ; ;; la función de aquí ^ me devuelve en HL el puntero de la memoria de vídeo
    ld e_prev_x(ix), l
    ld e_prev_y(ix), h

    ex  de, hl
    ld a, e_pos(ix)
    call sys_render_status_jet
    ; ld  hl, #_sp_nave
    ld  b,  e_w(ix)
    ld  c,  e_h(ix)
    call cpct_drawSpriteBlended_asm

    ret
sys_render_timer::
    push ix
    ld ix, #race_storage
    ld  de, #CPCT_VMEM_START_ASM
    ld  c,  #0x24 ;x
    ld  b,  #0xB5 ;y
    call cpct_getScreenPtr_asm
    ld e,race_time_m(ix) ; x:yy
    call cpct_drawCharM0_asm
    ld  de, #CPCT_VMEM_START_ASM
    ld  c,  #0x29 ;x
    ld  b,  #0xB5 ;y
    call cpct_getScreenPtr_asm
    ld ix,#race_storage
    ld e,race_time_s_1(ix) ; x:yy

    call cpct_drawCharM0_asm
     ld  de, #CPCT_VMEM_START_ASM
    ld  c,  #0x2c;x
    ld  b,  #0xB5 ;y
    call cpct_getScreenPtr_asm
    ld ix,#race_storage
    ld e,race_time_s_2(ix) ; x:yy
    call cpct_drawCharM0_asm
    pop ix

ret
sys_render_laps::
    ld  de, #CPCT_VMEM_START_ASM
    ld  c,  #0x09 ;x
    ld  b,  #0xB5 ;y
    call cpct_getScreenPtr_asm
    ld ix,#race_storage
    ld e,race_n_vuelta(ix) ; x:yy
    call cpct_drawCharM0_asm
ret

sys_render_wins::
    ld  de, #CPCT_VMEM_START_ASM
    ld  c,  #0x44 ;x
    ld  b,  #0xB5 ;y
    call cpct_getScreenPtr_asm
    ld ix,#race_storage
    ld e,race_wins(ix) ; x:yy
    call cpct_drawCharM0_asm
ret
sys_render_contador::


 ld  de, #CPCT_VMEM_START_ASM
    ld  c,  #0x2C ;x
    ld  b,  #0xB5 ;y
    call cpct_getScreenPtr_asm
    ld a, (num_cont)
    cp #3
    jr nz, No_Tres
    ld e,#0x33
    jr No_Cero
No_Tres:
    cp #2
    jr nz, No_Dos
    ld e, #0x32
    jr No_Cero

No_Dos:
    cp #1
    jr nz, No_Uno
    ld e, #0x31
    jr No_Cero

No_Uno:
    cp #0
    jr nz, No_Cero
    ld e,#0x30

No_Cero:
    call cpct_drawCharM0_asm
    ret

sys_render_win::
    ld hl,#_win_comp_end
    ld de,#0xFFFF
    call cpct_zx7b_decrunch_s_asm
    ret

sys_render_lose::
    ld hl,#_lose_comp_end
    ld de,#0xFFFF
    call cpct_zx7b_decrunch_s_asm
    ret